/***************************************************************************
                          HermodCall.h  -  description
                             -------------------
    begin                : Fri Feb 21 2003
    copyright            : (C) 2003 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/
#ifndef _HERMODCALL_H_
#define _HERMODCALL_H_

#include <stdlib.h>
#include <string>
#include <winsock.h>
using namespace std;
#include <vector>

#ifndef SOCKET
 #define SOCKET int
#endif

#ifndef BOOL
#define BOOL int
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif


#include "HermodResponse.h"


class HermodCall
{
	private:
		vector<HermodParameter> m_params;
		string m_methodName;
		string m_url;
		string m_connectionId;
		SOCKET m_soccketFd;
		string m_errorStr;

		BOOL connectToServer();
		int sendStr(string str);
		BOOL reciveStr(string &str);

	public:
		HermodCall();
		~HermodCall();

		void setTagetUrl(const char *url) {m_url = url;};
		void setTagetUrl(string url) {m_url = url;};
		void setMethodName(const char *method)  {m_methodName = method;};
		void setMethodName(string method)  {m_methodName = method;};
		void setParams(vector<HermodParameter> params) {m_params = params;};
		void setConnectionId(const char *id) {m_connectionId = id;};
		void setConnectionId(string id) {m_connectionId = id;};
		const char *getConnectionId() {return m_connectionId.c_str();};
		string getConnectionIdString() {return m_connectionId;};
		HermodResponse *setUserPassword(char *user, char *password);
		HermodResponse *getFreeConnection();
		HermodResponse *getConnection();
		HermodResponse *releaseConnection();
		HermodResponse *invoke();
};//HermodCall

#endif
