#ifdef WIN32

#include <windows.h>
#include <iostream.h>
#include "HermodCall.h"

int main(int argc, char *argv)
{
	HermodCall *call = new HermodCall();
	HermodParameter param;
	vector<HermodParameter> params;
	HermodResponse *response;
	HermodFault *fault;
	WORD wVersionRequested = MAKEWORD( 2, 2 );
	WSADATA wsaData;

	WSAStartup (wVersionRequested, &wsaData);

	call->setTagetUrl("http://localhost:5080/");
	call->setMethodName("rs17-connect-disconnect");

	param.setName("rs-17-input");
	param.setValue("100D000100010ECHO    pipo");
	params.push_back(param);
	call->setParams(params);

	if ((response=call->setUserPassword("CS4AA06", "abcde01"))==NULL) {
		cout << "Recived NULL Response" << endl;
		return 1;
	}
	else if (response->generatedFault()) {
		if ((fault=response->getFault())==NULL) {
			cout << "NULL Fault!!!" << endl;
			return 1;
		}
		else {
			cout << "Fault: " << fault->getFaultCode() << "  " <<fault->getFaultString() << endl;
			return 1;
		}
	}

	if ((response=call->invoke())==NULL) {
		cout << "Recived NULL Response" << endl;
		return 1;
	}
	else if (response->generatedFault()) {
		if ((fault=response->getFault())==NULL) {
			cout << "NULL Fault!!!" << endl;
			return 1;
		}
		else {
			cout << "Fault: " << fault->getFaultCode() << "  " <<fault->getFaultString() << endl;
			return 1;
		}
	}
	else {
		params.clear();
		params = response->getParams();
		for (int i=0; i<params.size(); i++) {
			param = params.at(i);
			cout << "Param: " << param.getName() << " = " << param.getValue() << endl;
		}
	}

	if ((response=call->releaseConnection())==NULL) {
		cout << "Recived NULL Response" << endl;
		return 1;
	}
	else if (response->generatedFault()) {
		if ((fault=response->getFault())==NULL) {
			cout << "NULL Fault!!!" << endl;
			return 1;
		}
		else {
			cout << "Fault: " << fault->getFaultCode() << "  " <<fault->getFaultString() << endl;
			return 1;
		}
	}

	delete call;
	WSACleanup();
	return 0;
}

#endif
