/*
 * HermodTest.java
 *
 * Created on February 5, 2003, 7:38 PM
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU GPL (General Public License) as published
 * by the Free Software Fondation:
 * http://www.gnu.org/copyleft/gpl.html
 */
import java.net.*;
import java.io.*;
import java.util.*;

/**
 *
 * @author  Henrik Baastrup (c) Feb 2003
 */
public class HermodTest
{
    
    public HermodTest()
    {
    }//HermodTest
    
    
    public static void main(String[] args)
    {
        com.hbaastrup.hermod.Call call = new com.hbaastrup.hermod.Call();
        com.hbaastrup.hermod.Response response;
        com.hbaastrup.hermod.Parameter param = new com.hbaastrup.hermod.Parameter();
        Vector params = new Vector(0);
        
        call.setTagetUrl("http://localhost:5080/");
//        call.setTagetUrl("http://itmow210:5080/");
        call.setMethodName("rs17-connect-disconnect");
        param.name = "rs-17-input";
        param.value = "100D000100010ECHO    Pipo";
        params.addElement(param);
        call.setParams(params);
//        call.setMethodName("fault-method");
        try {
            // Get a specific connection
//            call.setConnectionId("Connection4");
//            response = call.getConnection();
            // Get the first free connection
//            response = call.getFreeConnection();
            response = call.setUserPassword("CS4AA06", "abcde01");
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("NULL Fault!!!!!");
                return;
            }
            
            response = call.invoke();
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("NULL Fault!!!!!");
            }
            else {
                Vector vect = response.getParams();
                if (vect!=null) {
                    Enumeration enum = vect.elements();
                    while (enum.hasMoreElements()) {
                        param = (com.hbaastrup.hermod.Parameter)enum.nextElement();
                        System.out.println("Param: "+param.name+" = "+param.value);
                    }
                }
                else System.out.println("Null params!");
            }
            
            response = call.releaseConnection();
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("NULL Fault!!!!!");
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return;
        }
    }//main
}//HermodTest
