/*
 * HermodThreadTest.java
 *
 * Created on February 11, 2003, 2:18 PM
 */
import java.net.*;
import java.io.*;
import java.util.*;

/**
 *
 * @author  Henrik Baastrup (c) Feb 2003
 */
public class HermodThreadTest extends Thread
{
    private long delay = 10000;
    private boolean threadIsRunning = false;
    private int threadNum = 0;

    private com.hbaastrup.hermod.Call call;
    private com.hbaastrup.hermod.Response response;
    private com.hbaastrup.hermod.Parameter param;
    private String methodName = "rs17-connect-disconnect";
    
    public HermodThreadTest() 
    {
        super();
        call = new com.hbaastrup.hermod.Call();
        call.setTagetUrl("http://localhost:5080/");
//        call.setTagetUrl("http://itmow210:5080/");
        param = new com.hbaastrup.hermod.Parameter();
        threadIsRunning = false;
    }//HermodThreadTest
    
    
    public void run()
    {
        System.out.println("Thread# "+threadNum+" Started");
        while (threadIsRunning) {
            System.out.println("Thread# "+threadNum+" I am sleepy ZZZzzz");
            try {
                sleep(delay);
            } catch (Exception doNothing) {}
            System.out.println("Thread# "+threadNum+" Wokeup");
            if (!threadIsRunning) break;
           
            doRequest();
        }
    }//run
    
    public void start()
    {
        if (threadIsRunning) return;
        threadIsRunning = true;
        super.start();
    }//start
    
    public void stopHermodThreadTest()
    {
        threadIsRunning = false;
    }
    
    public void setDelay(long aDelay) {delay = aDelay;}
    public boolean isThreadRunning() {return threadIsRunning;}
    public void setThreadNum(int num) {threadNum = num;}
    public void setMethodName(String method) {methodName = method;}
    
    
    void doRequest()
    {
        Vector params = new Vector(0);

        call.setMethodName(methodName);
        param.name = "rs-17-input";
        param.value = "100D000100010ECHO    Pipo";
        params.addElement(param);
        call.setParams(params);
        try {
            // Get a specific connection
            call.setConnectionId("Connection"+threadNum);
            response = call.getConnection();
            // Get the first free connection
//            response = call.getFreeConnection();
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Thread# "+threadNum+" Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("Thread# "+threadNum+" NULL Fault!!!!!");
                return;
            }
System.out.println("Thread# "+threadNum+" Connection ID before setUserPassword: "+call.getConnectionId());

            response = call.setUserPassword("CS4AA06", "abcde01");
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Thread# "+threadNum+" Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("Thread# "+threadNum+" NULL Fault!!!!!");
                return;
            }
System.out.println("Thread# "+threadNum+" Connection ID before invoke: "+call.getConnectionId());

            response = call.invoke();
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Thread# "+threadNum+" Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("Thread# "+threadNum+" NULL Fault!!!!!");
            }
            else {
                Vector vect = response.getParams();
                if (vect!=null) {
                    Enumeration enum = vect.elements();
                    while (enum.hasMoreElements()) {
                        param = (com.hbaastrup.hermod.Parameter)enum.nextElement();
                        System.out.println("Thread# "+threadNum+" Param: "+param.name+" = "+param.value);
                    }
                }
                else System.out.println("Thread# "+threadNum+" Null params!");
            }
System.out.println("Thread# "+threadNum+" Connection ID before release: "+call.getConnectionId());
            
            response = call.releaseConnection();
            if (response.generatedFault()) {
                com.hbaastrup.hermod.Fault fault = response.getFault();
                if (fault!=null) {
                    System.out.println("Thread# "+threadNum+" Fault: "+fault.getFaultCode()+"   "+fault.getFaultString());
                }
                else System.out.println("Thread# "+threadNum+" NULL Fault!!!!!");
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//doRequest


    public static void main(String[] args)
    {
        HermodThreadTest test[];
        
        test = new HermodThreadTest[3];
        for (int i=0; i< test.length; i++) {
            test[i] = new HermodThreadTest();
            test[i].setThreadNum(i+1);
            test[i].setMethodName("rs17-connect-disconnect");
            test[i].start();
        }
    }//main
}//HermodThreadTest
