/***************************************************************************
                          TestMain.cpp  -  description
                             -------------------
    begin                : Tue May 14 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU LGPL (Lesser general Public License) 
 *   as published by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/lesser.html or in the file copying.txt
 *
 ***************************************************************************/

#include "ConnectionWrapper.h"

int main(int argc, char *argv[])
{
	ConnectionWrapper *testWrap;
	ConnectionId connId;
	ConnParameter param, *p, **outParams;
	int rVal;

	strcpy(HllapiFileName,"C:\\Program Files\\Personal Communications\\EHLAPI32.dll");
	strcpy(PcsapiFileName,"C:\\Program Files\\Personal Communications\\pcsapi32.dll");

	connId.sessionName = 'A';
	strcpy(connId.wsProfileFileName, "C:\\Program Files\\Personal Communications\\private\\isti.WS");
	strcpy(connId.scriptsFileName, "C:\\Projects\\hermod\\config.xml");
	*connId.emulCommand ='\0';
	connId.timeOutSec = 30;

	testWrap = new ConnectionWrapper(&connId, 1);
	testWrap->parseScriptFile(connId.scriptsFileName);
	param.setScriptName("connect");
	param.setParamName("user");

	outParams = testWrap->getAllOutputParameters("rs17-connect");
	int i=0;
	do {
		p = outParams[i];
		if (p) delete p;
		i++;
	} while (p!=NULL);
	delete []outParams;

	rVal = testWrap->getParameter(&param);
	param.setValue("CS4AA06");
	rVal = testWrap->setParameter(&param);
	rVal = testWrap->getParameter(&param);
	param.setParamName("password");
	param.setValue("abcde01");
	rVal = testWrap->setParameter(&param);
	rVal = testWrap->getParameter(&param);

	rVal = (int)testWrap->doCommand(CONN_COMM_OPEN_CONNECTION, NULL);

	param.setScriptName("rs17-connect");
	param.setParamName("rs-17-input");
	if ((rVal=testWrap->getParameter(&param))!=0) {
		printf("rs-17-input is wrong\n");
		return 1;
	}
	printf("Send: %s\n",param.value);

	rVal = (int)testWrap->doCommand(CONN_COMM_DO_SCRIPT_COMMAND, (void *)"rs17-connect");
	param.setParamName("rs-17-output");
	if ((rVal=testWrap->getParameter(&param))!=0) printf("Recived NULL\n");
	else printf("Recived: %s\n",param.value);
	rVal = (int)testWrap->doCommand(CONN_COMM_DO_SCRIPT_COMMAND, (void *)"rs17-disconnect");

	rVal = (int)testWrap->doCommand(CONN_COMM_DISCONNECT, NULL);
	delete testWrap;
	return 0;
}//main
