/***************************************************************************
                          ThreadIntefaceWin32.h  -  description
                             -------------------
    begin                : Tue May 14 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : hba@libero.it
    home page            : http://digilander.iol.it/hba/Linux/index.html
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU GPL (General Public License) as published
 *   by the Free Software Foundation:
 *   http://www.gnu.org/copyleft/gpl.html or in the file copying.txt
 *
 ***************************************************************************/
#ifdef WIN32
#ifndef _THREDINTERFACE_H_
#define _THREDINTERFACE_H_


#ifndef _WINDOWS_H_INCLUDED_
  #define _WINDOWS_H_INCLUDED_
  #include <windows.h>
#endif

class MutexClass
{
	private:
		CRITICAL_SECTION m_mutex;

	public:
		MutexClass();
		~MutexClass();
		int lock();
		int unlock();
};//MutexClass


class Event
{
	private:
		HANDLE m_hEvent;

	public:
		Event();
		~Event();
		int wait();
		int set();
};//Event


class ThreadClass
{
	private:
		HANDLE m_threadH;
		DWORD  m_threadId;
		void *m_threadArg;
		DWORD (*m_startRutine)(void *);
		int m_doNotKillMe;

	public:
		ThreadClass(DWORD (*)(void *), void *);
		~ThreadClass();
		int start();
		void kill();
		void *callStartRutine();
		void doNotKillMe() {m_doNotKillMe = 1;};
};//ThreadClass

#ifndef LOCAL_INCLUDE
extern void ThreadSleep(int sec);
#endif

#endif
#endif
