/***************************************************************************
                          pipeFifo.cpp  -  description
                             -------------------
    begin                : Tue Jul 23 2002
    copyright            : (C) 2002 by Henrik Baastrup
    email                : henrik.baastrup@eds.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	char fifoName[1024];
	char buffer[1025];
	int i, fifoOut;

	strcpy(fifoName,"/tmp/pipeFifo.1");

	if (argc > 1) strcpy(fifoName, argv[1]);

	unlink(fifoName);

	if (mknod(fifoName, S_IFIFO | 0666, 0) < 0) {
		printf("ERROR in mknod fifo:%s\n",fifoName);
		return EXIT_FAILURE;
	}

	if ((fifoOut=open(fifoName, O_WRONLY)) < 0) {
		printf("ERROR in open fifo: %s\n",fifoName);
		return EXIT_FAILURE;
	}

	for (;;) {
		if (fgets(buffer, 1024, stdin)==NULL) break;
		i = strlen(buffer);
		write(fifoOut, buffer, i);
	}

	close(fifoOut);
	unlink(fifoName);
	return EXIT_SUCCESS;
}
